



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>javascript作用域和作用域链</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">javascript作用域和作用域链</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-01 02:23:11 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>1、作用域</strong></p>
<p>　　作用域，它是指对某一变量和方法具有访问权限的代码空间。当我们在定义变量的时候，会定义两种变量，一种是在全局环境下定义的变量，叫全局变量，一种是在函数中定义的变量叫局部变量。全局变量的作用域就是全局环境，局部变量的作用域就是函数。</p>
<p><strong>2、作用域链</strong></p>
<p>　　javascript高级程序设计书中写到，当代码在一个环境中执行时，会创建变量对象的一个作用域链。作用域链的用途，是保证对执行环境有权访问的所有变量和函数的有序访问。作用域链的前端，始终都是当前执行的代码所在环境的变量对象。 作用域链中的下一个变量对象来自包含(外部)环境，而再下一个变量则来自下一个包含环境，这样一直延续到全局执行环境；全局执行环境的变量对象始终都是作用域链中的最后一个对象。</p>
<p>　　简单来说就是，当我查找一个变量时，我会先在自己所在的环境找，找不到延着作用域链继续向外一层的环境找，找不到再向外找，一直找到全局执行环境中。</p>
<p>　　看一小段代码：</p>
<p>　　</p>
<div>
<pre class="prettyprint linenums"> var colorA = "red";<br />
     function abc(){<br />
         var colorB = "blue";<br />
         function info(){<br />
              var  color ="yellow";<br />
              console.log(colorA);-------1<br />
              console.log(colorB);-------1<br />
              console.log(colorC);-------1<br />
        };<br />
        info();<br />
         console.log(colorA);-------2<br />
         console.log(colorB);-------2<br />
         console.log(colorC);-------2<br />
     };<br />
 abc();<br />
 console.log(colorA);-------3<br />
 console.log(colorB);-------3<br />
 console.log(colorC);-------3 </pre>
</div>
<p>　　在上述代码中，你可以发现，标记为1的，三个颜色A、B、C都能正确的被找到并打印出来。而标记为2的，只能找到A、B颜色。而标记为3的，只能够找到A颜色。</p>
<p>　　出现这种情况的原因就是去查找变量值的时候，是先从自身所在的环境中查找，没找到的时候，沿着作用域链向外层查找，所以在内层可以访问到外层定义的变量，在外层是访问不到内层所定义的变量的。</p>
<p><strong>3、块级作用域和函数作用域</strong></p>
<p>　　我们都听说过javscript是没有块级作用域的，javascript执行的是函数作用域，那么什么是块级作用域呢？</p>
<p>　　任何一对花括号（｛和｝）中的语句集都属于一个块，在这之中定义的所有变量在代码块外都是不可见的，我们称之为块级作用域。</p>
<p>　　什么是函数作用域？</p>
<p>　　简单来说函数中的参数和变量在函数外部是不可见的，只在函数内部可以访问。</p>
<p>　　为什么说javascript没有块级作用域，看一段以下代码：</p>
<p>　　</p>
<div>
<pre class="prettyprint linenums"> var color="red";<br />
 if(true){<br />
     var color = "blue";<br />
     console.log(color);<br />
 }<br />
 console.log(color);</pre>
</div>
<p>　　会发现两个输出的都是blue，如果有块级作用域的话，if里面的color会被当做局部变量创建，这样子的话输出的就是"blue","red"了;正是因为没有块级作用域，if里面对color的赋值被当做是全局变量把原来的值覆盖掉，所以输出才会是两个都是blue;</p>
<p><strong>4、变量声明提升</strong></p>
<p>　　先来看一小段代码，你认为的输出是什么:</p>
<p>　　</p>
<div>
<pre class="prettyprint linenums"> var a = 100;<br />
 function testResult(){<br />
   var b = 2 * a;<br />
   var a = 200;<br />
   var c = a / 2;<br />
   console.log(b);<br />
   console.log(c);<br />
 }<br />
 testResult();</pre>
</div>
<p>　　我们先不管上面的输出是什么，先来看看这几行代码的输出是什么；</p>
<p>　　console.log(a);var a = 123; &nbsp;//undefined;</p>
<p>　　console.log(a);var a ;　　//undefined;</p>
<p>　　var a = 123;console.log(a); &nbsp; //123;</p>
<p>　　出现这种情况就是因为变量声明提升，我们去声明一个变量的时候javascript引擎会把变量"提前"声明，而把赋值放在原来的顺序。</p>
<p>　　所以console.log(a);var a = 123;的执行顺序其实是var a; console.log(a); a = 123;</p>
<p>　　故输出a的时候只是创建了变量还没有被赋值，所以输出为undefined;</p>
<p>　　现在再来看看刚那段代码的执行顺序其实是:</p>
<p>　　</p>
<div>
<pre class="prettyprint linenums"> var a = 100;<br />
 function testResult(){<br />
     var b;<br />
     var a;<br />
     var c;<br />
     b = 2 * a; //此时在局部变量中找到了a，故不会再向上找全局变量a = 100; 但是a还没被赋值,a为undefined,故此时b为NaN;<br />
     a = 200;<br />
     c = a / 2;  // 100;<br />
     console.log(b);  //NaN<br />
     console.log(c);  //100<br />
 }<br />
  testResult();</pre>
</div>
<p>注:对undefined作加减乘除会把它转化为数字类型，undefined转化为数字类型就是NaN;</p>
<p>故输出为 NaN 和 100 ;</p>
<p>　　</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqvly7o8.html">linux下批量查找&sol;替换文本内容</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1jo4k8.html">kuangbin&lowbar;ShortPath O &lpar;LightOJ 1074&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xm7ne8.html">html5 canvas防微博旋转</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w3k6lq.html">使ViewFlipper中的WebView实现手势效果</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnjg608.html">各大浏览器内核（Rendering Engine）</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x2gen9.html">linux &mdash;&mdash; shell 编程（整体框架与基础笔记）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ey15xk9.html">nyoj 55 懒省事的小明 优先队列 multiset 还有暴力</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdjz2k9.html">Mina框架断包、粘包问题解决方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/8meeo5rq.html">printf  对齐</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdp56m7q.html">HDU 5534 Partial Tree</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojg3k5q.html">大数的加法运算，杭电oj-1002</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yv3yw8.html">call&comma;apply和bind，其实很简单</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zop6yxq.html">关于Java的异常</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z5zox9.html">scala 访问阿里云oss</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2rkwj9.html">JS&lowbar;高程7&period;函数表达式（1）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjwg0j9.html">linux命令 find的应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qve21pj9.html">recordMyDesktop的安装与使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gp3lr79.html">几种常见web攻击手段及其防御方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7enynx9.html">防范SQL注入漏洞攻击</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnngmygq.html">js 3行代码，最简易实现div效果悬浮</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qlm4dj19.html">debian系（Ubuntu）安装jenkins（持续集成）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j036peq.html">Spring MVC  之 Hello World</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rdxll48.html">Kendo Web UI  Grid添加一个html控件如（checkbox&comma;button&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2w41zlq.html">jquery的queue方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gmwvjz9.html">php 之 数据访问  增删改查练习题</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4y0ve0q.html">PHP 中const 与define 区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/qde2ygj9.html">《python基础教程》笔记之 元组</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pjrrzy9.html">Android4&period;0强制横屏竖屏</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7mrkj1q.html">Android开发的体会</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2w4r2wq.html">zoj2314 经典 无源汇有上下界最大流 并输出可行流</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
